﻿Imports System.Runtime.CompilerServices
Imports System.Runtime.InteropServices

''' Unsignd Short, Integer を Signed にキャストする。
''' 
''' Dim a As UInt16 = HFFFE
''' Dim b As Int16
''' b = a.ToSigned ----- これは -2 になる
'''
''' Dim c As UInt32 = HFFFFFFFEUI
''' Dim d As Int32 = a.ToSigned
''' 
Module SignConversionExtensions16
    <StructLayout(LayoutKind.Explicit)>
    Private Structure Union
        <FieldOffset(0)> Public Int16 As Int16
        <FieldOffset(0)> Public UInt16 As UInt16
    End Structure

    <Extension()> Public Function ToSigned(ByVal n As UInt16) As Int16
        Return New Union() With {.UInt16 = n}.Int16
    End Function

    <Extension()> Public Function ToUnsigned(ByVal n As Int16) As UInt16
        Return New Union() With {.Int16 = n}.UInt16
    End Function

End Module

Module SingConversionExtensions32
    <StructLayout(LayoutKind.Explicit)>
    Private Structure Union
        <FieldOffset(0)> Public Int32 As Int32
        <FieldOffset(0)> Public UInt32 As UInt32
    End Structure

    <Extension()> Public Function ToSigned(ByVal n As UInt32) As Int32
        Return New Union() With {.UInt32 = n}.Int32
    End Function

    <Extension()> Public Function ToUnsigned(ByVal n As Int32) As UInt32
        Return New Union() With {.Int32 = n}.UInt32
    End Function
End Module